package G1.bank_locks;

import java.util.Random;
import java.util.concurrent.locks.ReentrantLock;

public class Bank {

	private Random randGen = new Random();
	private String[] names = new String[]{"Mira", "Pera", "Zika", "Petar", "Ana"};
	private Client[] clients;
	private ReentrantLock lock;
	
	public Bank(int n, int initialBalance) {
		lock = new ReentrantLock();
		clients = new Client[n];
		for(int i=0; i<n; i++){
			clients[i]=new Client(names[randGen.nextInt(names.length)], i, initialBalance, this);
		}
		for(int i=0; i<n; i++)
			new Thread(clients[i]).start();
	}
	
	void transfer(int from, int to, int amount){
		lock.lock();
		clients[from].addToBalance(-amount);
		clients[to].addToBalance(amount);
		lock.unlock();
		/* ispis nije osiguran, tako da se moze desiti da povremeno 
		ispise pogresan total, ali se uvek kasnije vrati na normalu */
		/* ako bismo hteli da osiguramo i total, trebalo bi sa istim lock objektom */
		System.out.println(total());
	}
	
	private int total(){
		int sum=0;
		for(Client c: clients)
			sum+=c.getBalance();
		return sum;
	}
	
	public int getClientCount(){
		return clients.length;
	}
	
	public static void main(String[] args) {
		Bank bank = new Bank(100, 100);
	}
}
